searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for Hammer.Backend.EredisCluster\n\nThis backend uses the [eredis_cluster](https://hex.pm/packages/eredis_cluster) library to connect to Redis.\n\nThe backend process is started by calling `start_link`:\n\n    Hammer.Backend.EredisCluster.start_link(\n      expiry_ms: 60_000 * 10,\n      eredis_cluster_name: :mycluster,\n      eredis_cluster_init_servers: [\n        {\"127.0.0.1\", 30001},\n        {\"127.0.0.1\", 30002},\n        {\"127.0.0.1\", 30003}\n      ],\n      eredis_options: [\n        username: \"myuser\",\n        password: \"mypassword\"\n      ]\n    )\n\nOptions are:\n\n- `expiry_ms`: Expiry time of buckets in milliseconds,\n  used to set TTL on Redis keys. This configuration is mandatory.\n- `eredis_cluster_name`: The `eredis_cluster` name to use.\n- `eredis_cluster_init_servers`: List of tuples of hostname (or IP address) and port number pairs.\n- `eredis_options`: Keyword list of options that are passed down to `eredis`.","ref":"Hammer.Backend.EredisCluster.html","title":"Hammer.Backend.EredisCluster","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hammer.Backend.EredisCluster.html#child_spec/1","title":"Hammer.Backend.EredisCluster.child_spec/1","type":"function"},{"doc":"Record a hit in the bucket identified by `key`","ref":"Hammer.Backend.EredisCluster.html#count_hit/3","title":"Hammer.Backend.EredisCluster.count_hit/3","type":"function"},{"doc":"Record a hit in the bucket identified by `key`, with a custom increment","ref":"Hammer.Backend.EredisCluster.html#count_hit/4","title":"Hammer.Backend.EredisCluster.count_hit/4","type":"function"},{"doc":"Delete all buckets associated with `id`.","ref":"Hammer.Backend.EredisCluster.html#delete_buckets/2","title":"Hammer.Backend.EredisCluster.delete_buckets/2","type":"function"},{"doc":"Retrieve information about the bucket identified by `key`","ref":"Hammer.Backend.EredisCluster.html#get_bucket/2","title":"Hammer.Backend.EredisCluster.get_bucket/2","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#make_redis_key/1","title":"Hammer.Backend.EredisCluster.make_redis_key/1","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#make_redis_key_pattern/1","title":"Hammer.Backend.EredisCluster.make_redis_key_pattern/1","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#start/0","title":"Hammer.Backend.EredisCluster.start/0","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#start/1","title":"Hammer.Backend.EredisCluster.start/1","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#start_link/0","title":"Hammer.Backend.EredisCluster.start_link/0","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#start_link/1","title":"Hammer.Backend.EredisCluster.start_link/1","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#stop/0","title":"Hammer.Backend.EredisCluster.stop/0","type":"function"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#t:bucket_info/0","title":"Hammer.Backend.EredisCluster.bucket_info/0","type":"type"},{"doc":"","ref":"Hammer.Backend.EredisCluster.html#t:bucket_key/0","title":"Hammer.Backend.EredisCluster.bucket_key/0","type":"type"},{"doc":"# Overview\n\nA Clustered Redis backend for the Hammer rate-limiter\n\n[Hammer](https://github.com/ExHammer/hammer) is a rate-limiter for\nthe [Elixir](https://elixir-lang.org/) language. It's killer feature is a\npluggable backend system, allowing you to use whichever storage suits your\nneeds.\n\nThis package provides a Clustered Redis backend for Hammer, using\nthe [eredis_cluster](https://github.com/Nordix/eredis_cluster) library to connect to the\nRedis server.\n\nTo get started, read\nthe [Hammer Tutorial](https://hexdocs.pm/hammer/tutorial.html) first, then add\nthe `hammer_backend_eredis_cluster` dependency:\n\n```elixir\n    def deps do\n      [{:hammer_backend_eredis_cluster, \"~> 1.0\"},\n      {:hammer, \"~> 6.1\"}]\n    end\n```\n\n... then configure the `:hammer` application to use the Redis backend:\n\n```elixir\nconfig :hammer,\n  backend: {Hammer.Backend.Eredis, [expiry_ms: 60_000 * 60 * 2,\n                                   eredis_cluster_init_servers: [{\"localhost\", 6379}, {\"localhost\", 6380}, {\"localhost\", 6381}]]}\n```\n\n(the `redix_config` arg is a keyword-list which is passed to Redix, it's also\naliased to `redis_config`, with an `s`)\n\nAnd that's it, calls to `Hammer.check_rate/3` and so on will use Redis to store\nthe rate-limit counters.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Initial release.","ref":"changelog.html#1-0-0-2023-12-12","title":"1.0.0 (2023-12-12) - CHANGELOG","type":"extras"}]}